//*****************************************************************************
//*
//*
//*     FtpServer.h
//*
//*
//*****************************************************************************
#ifndef     __FTPSERVER_H__
#define     __FTPSERVER_H__

#define     FTP_API             extern "C"



// ftp server errors

#define     FTP_ERR_NONE            0                   // no error
#define     FTP_ERR_SOCKET          1                   // socket error
#define     FTP_ERR_ISRUNNING       2                   // ftp server is allready running
#define     FTP_ERR_ISNOTRUNNING    3                   // ftp server is not running
#define     FTP_ERR_WRONGIP         4                   // the ip address is wrong
#define     FTP_ERR_INIT            5                   // initialization error
#define     FTP_ERR_NOTSTOPED       6                   // the server could not stopped
#define     FTP_ERR_WRONGPATH       7                   // a worong path was defined
#define     FTP_ERR_DOMUCHSHARES    8                   // too much shares defined
#define     FTP_ERR_WRONGNAME       9                   // wrong share name
#define     FTP_ERR_NEED_LOGINCB    10                  // we need a login callback
#define     FTP_ERR_DOUBLENAME      11                  // double share name


#ifndef	   _MSC_VER
#ifndef    _cdecl
#define    _cdecl
#endif
#endif


#ifdef  __cplusplus
#define D(a)    a
extern "C" {
#else
#define D(a)
#endif

typedef void *FtpConnection;

typedef int  (_cdecl *FtpLoginCB      )(FtpConnection hConn,const char *pUser,const char *pPassword);
typedef int  (_cdecl *FtpConnectCB    )(FtpConnection hConn,const char *pIpAddr,unsigned short usPort);
typedef void (_cdecl *FtpDisconnectCB )(FtpConnection hConn,const char *pIpAddr,unsigned short usPort);
typedef int  (_cdecl *FtpFileCheckerCB)(FtpConnection hConn,const char *pPath,const char *pName,void *pParam,int iShare);

typedef struct
    {
    char                cIpAddress [ 64];                   // ip addres off the http-server
    char                cFilePath  [256];                   // is the path for server files
    unsigned short      usTcpPort;                          // is the tcp port for the server
    unsigned            uTimeout;                           // receive timeout in ms
    int                 iMaxConnections;                    // maximum count of client connections
    int                 iPriority;                          // taks priority 0-256
    int                 iReadOnly;                          // is the path read only
    int                 iNoAnonym;                          // don't allow an anonymous login
    FtpLoginCB          pCbLogin;                           // callback for a client login
    FtpConnectCB        pCbConnect;                         // callback for client connection
    FtpDisconnectCB     pCbDisconnect;                      // callback for client disconnection
    FtpFileCheckerCB    pCbChecker;                         // callback for file checking
    void               *pCbCheckerParam;                    // parameter for file checking
    }FtpConfigData;


//*****************************************************************************
//*
//*     Functions
//*
//*****************************************************************************

int         FtpStopDaemon();
int         FtpDaemon         (FtpConfigData *pConfig);
int         FtpInsertTreeEntry(FtpConnection hConn,const char *pName,const char *pPath,int iReadOnly D(=0),FtpFileCheckerCB pCheckCb D(=0),void *pParam D(=0));
int         FtpGetUserValue   (FtpConnection hConn,unsigned    uNumber);
void        FtpSetUserValue   (FtpConnection hConn,unsigned    uNumber,int iValue);
void       *FtpGetUserPointer (FtpConnection hConn,unsigned    uNumber);
void        FtpSetUserPointer (FtpConnection hConn,unsigned    uNumber,void *pPointer);

#ifdef  __cplusplus
}
#endif

#undef  D


#endif





